/*
 * pict conversion to pdf for rtf2latex2e
 * (c) 2003 Richard Bornat
 * This uses the ImageMagick API.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
# include	<stdio.h>
# include	<stdlib.h>
# include <sys/wait.h>
# include <unistd.h>
# include "pictfuns.h"

int Pict2pdf(SafeBuf infile) { // 0 means success, exit-style (hmm).
#if __GNUC__
    pid_t pid;
    int err = 0;
    static char *pict;

    pid = fork();

    switch(pid) {
      case -1:
        printf("Pict2pdf: fork failed!\n");
        return 1;
      case 0:
        pict = infile->_buf;
        err = execlp("pict2pdf", "pict2pdf", "-f", pict, (char *)0);
        /* if we reach here, the convert utility could not be found */
        printf("no pict2pdf installed!\n");
        exit(1);
        return 1; /* I'm joking, of course */
    default: {
        int stat_val;
        pid_t child_pid;

        /* wait for the conversion process to finish */
        child_pid = wait(&stat_val);
        if (WIFEXITED(stat_val) && !WEXITSTATUS(stat_val))
            return 0;
        else {
            printf("pict2pdf exit status %d!\n", stat_val);
            return 1;
        }
        }
    }
#else
        printf("not GNUC!!\n");
	return 1;
#endif		
}