/*
 * $Id: rtf2LaTeX2e.h,v 1.5 2005/05/01 12:35:58 oldgit Exp $
 * header file for RTF-to-LaTeX2e translation writer code.
 * (c) 1999 Ujwal S. Sathyam
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


# define	rtf2latex2e_version "1.0 fc3"

# define	WRAP_LIMIT	120
# define	PACKAGES	9

#ifndef boolean
typedef unsigned char boolean;
#endif
# define	New(t, fmt, arg)	((t *) RTFAlloc (sizeof (t), fmt, arg))
# define	Swap(a, b) {double tmp;\
						tmp = a;\
						a = b;\
						b = tmp;}

/* figure out the system we are compiling for */
#if defined(__MWERKS) && (defined(__POWERPC__) || defined(__CFM68K__) || defined(__MC68K__))
	/* check for Macintosh */	
	# include	<unix.mac.h>
	# include 	"Main.h"
	# define	PATH_SEP	':'
	# define	RTF2LATEX2E_MAC	1
#elif defined(WIN32)			
	/* check for Windows */
	# define	PATH_SEP	'\\'
	# define	RTF2LATEX2E_DOS	1
# else
	/* default to UNIX */																	
	# define	PATH_SEP	'/'
	# define	RTF2LATEX2E_UNIX	1
#endif


#ifndef false
	#define false 0
#endif

#ifndef true
	#define true 1
#endif

#ifndef size_t
	/* autoconf defines size_t as unsigned if not defined */
#	define size_t unsigned long /* 'unsigned' changed to 'unsigned long' by Ujwal Sathyam */
#endif


void	WriterInit (void);
int	BeginLaTeXFile (void);
void EndLaTeXFile (void);

void RTFSetOutputStream (FILE *ofp);


enum pictType {unknownPict, pict, wmf, gif, jpeg, bin, png};
enum objClass {unknownObj, Equation, equation, WordPicture, MSGraphChart};
enum word97ObjectClass {unknownWord97Object, word97Object, standardObject, word97Picture, word97ObjText};
enum {left, center, right};
enum {singleSpace, oneAndAHalfSpace, doubleSpace};
typedef enum {tinySize, scriptSize, footNoteSize, smallSize, normalSize, 
			largeSize, LargeSize, LARGESize, giganticSize, GiganticSize} fontSize;
enum cellMergeFlag {none, first, previous};
//typedef struct cell cell;
extern char *objectClassList[], *justificationList[], *environmentList[], *fontSizeList[];

typedef struct 
{
	int	count;
	int	type;
	long	width;
	long	height;
	long	goalWidth;
	long	goalHeight;
	long	scaleX;
	long	scaleY;
	int		llx;
	int		lly;
	int		urx;
	int		ury;
	char	name[rtfBufSiz];
} pictureStruct;

typedef struct
{
	int count;
} equationStruct;

typedef struct
{
	boolean	newStyle;
	int		boldGroupLevel;
	int		noBoldGroupLevel;
	boolean	wroteBold;
	boolean	wroteNoBold;
	int		italicGroupLevel;
	int		noItalicGroupLevel;
	boolean	wroteItalic;
	boolean	wroteNoItalic;
	int		underlinedGroupLevel;
	int		noUnderlinedGroupLevel;
	boolean	wroteUnderlined;
	int		dbUnderlinedGroupLevel;
	int		noDbUnderlinedGroupLevel;
	boolean	wroteDbUnderlined;
	int		shadowedGroupLevel;
	int		noShadowedGroupLevel;
	boolean	wroteShadowed;
	int		allCapsGroupLevel;
	boolean	wroteAllcaps;
	int		smallCapsGroupLevel;
	boolean	wroteSmallCaps;
	long	foreColor;
	int		foreColorGroupLevel;
	boolean	wroteForeColor;
	long	backColor;
	int		backColorGroupLevel;
	boolean	wroteBackColor;
	int		subScriptGroupLevel;
	int		noSubScriptGroupLevel;
	boolean	wroteSubScript;
	boolean	wroteNoSubScript;
	int		superScriptGroupLevel;
	int		noSuperScriptGroupLevel;
	boolean wroteSuperScript;
	boolean wroteNoSuperScript;
	long	fontSize;
	int		fontSizeGroupLevel;
	boolean	wroteFontSize;
	boolean	open;
} textStyleStruct;


typedef struct cell
{
	long	x;
	long	y;
	long	left;
	long	right;
	double	width;
	int		columnSpan;
	int		index;
	int		mergePar;	
	long	textColor;
	boolean	textBold;
	boolean	textItalic;
	boolean	textUnderlined;
	struct cell	*nextCell;
} cell;

typedef struct
{
	boolean	inside;
	int		rows;
	int		cols;
	int		cellCount;
	long	leftEdge;
	cell	*cellInfo;
	int		rowInfo[rtfBufSiz];
	long	*columnBorders;
	int		cellMergePar;
	long	previousColumnValue;
	boolean	newRowDef;
    boolean multiCol;
    boolean multiRow;
} tableStruct;

/* Prototypes */

#if RTF2LATEX2E_MAC
OSType Str2OSType(char *theStr);
#endif
extern void usage(void);
extern boolean IsValidPref (char *name, char *pref);
extern short 		ReadPrefFile (char *file);
extern short ReadR2LMap (void);
extern short R2LItem (char *name);
extern int			GetPreferenceNum (char *name);
extern void	InitializeGroupLevels (void);
extern void StoreGroupLevels (void);
extern void RestoreGroupLevels (void);
extern void	InitializeTextStyle (void);
extern void	TextClass (void);
extern void	ControlClass (void);
extern void GroupClass (void);
extern void SkipGroup (void);
extern void	Destination (void);
extern void WriteColours (void);
extern void	ReadFootnote (void);
extern void	SpecialChar (void);
extern void	PutStdChar (int	stdCode);
extern void	PutLitChar (int	c);
extern void	PutLitStr (char	*s);
extern void WrapText (void);
extern void WriteLaTeXHeader (void);
extern void CharAttr (void);
extern void ParAttr (void);
extern void CheckForCharAttr (void);
extern void ForceCloseCharAttr (void);
extern void WriteColor (void);
extern void DefineColors (void);
extern void CheckForParagraph (void);
extern void ReadFieldInst (void);
extern void CheckForMathMode (void);
extern void ReadPicture (void);
extern int  HexData (void);
extern void WritePictureHeader (FILE *pictureFile);
extern void ConvertHexPicture (const char *pictureType);
extern void ReadObject (void);
extern void GetObjectClass (int *groupCounter);
extern int  ReachedResult (int *groupCount);
extern void		ExamineToken (void);
extern void ReadWord97Object (void);
extern void ReadWord97Result (void);
extern boolean ReadEquation (int *groupCount);
extern U32 ReadObjectData (char *objectFileName, int type, int offset);
extern int	DecodeOLE (char *objectFileName, char *streamType, 
            unsigned char **nativeEquationStream, size_t *equationSize);  
extern void DoTable (void);
extern void DoTableAttr (void);
extern void	PrescanTable (void);
extern void	CellsIntoStraightColumns (void);
extern void DoMergedCells (cell *cellPtr);
extern void	ProcessTableRow (int rowNum);
extern void	ReadCell (void);
extern cell *GetCellInfo (int cellNum);
extern cell *GetCellByPos (int x, int y);
extern int	GetColumnSpan (cell *cellPtr);
extern void WriteCellHeader (int cellNum);
extern void DrawTableRowLine (int rowNum);
extern void	InheritTableRowDef (void);
extern void ExamineTextStyle (void);
extern void	CheckForBeginDocument (void);
extern void	SetTextStyle (void);
extern void	WriteTextStyle (void);
extern void	WriteParagraphStyle (void);
extern void IndentParagraph (void);
extern void DoParagraphCleanUp (void);
extern void SectAttr (void);
extern void	WriteSectionStyle (void);
extern void	DoSectionCleanUp (void);
extern int			ConvertPICT2EPS (char *fname);
extern void IncludeGraphics (char *pictureType);
extern int	CountCharInString (char *theString, char theChar);
extern void ReadHyperlink (void);
extern void	InsertNewLine (void);