/*
 *  rtftypes.h
 * header file for RTF-to-LaTeX2e translation writer code.
 * (c) 2003 Richard Bornat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __RTFTYPES__

    #define __RTFTYPES__

    #include <stdint.h>
    #include <ctype.h>
    #include "config.h"
    
    /* F32 */
    #if SIZEOF_FLOAT == 4
    #define F32     float
    #elif SIZEOF_DOUBLE == 4
    #define F32     double
    #elif SIZEOF_LONG_DOUBLE == 4
    #define F32     long double
    #else
    #error No 4 byte length float type found. Get another compiler.
    #endif
    
    /* F64 */
    #if SIZEOF_DOUBLE == 8
    #define F64     double
    #elif SIZEOF_LONG_DOUBLE == 8
    #define F64     long double
    #else
    #error No 8 byte length float type found. Get another compiler.
    #endif
    
    typedef uint8_t U8;
    typedef uint16_t U16;
    typedef uint32_t U32;

#endif /* __RTFTYPES__ */