/*
 *  rtfutils.h
 * header file for RTF-to-LaTeX2e translation writer code.
 * (c) 2003 Richard Bornat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __RTFUTILS__

    #define __RTFUTILS__

    /* stdarg.h is iso; so is stdio.h; but asprintf/vasprintf aren't.
       So I crafted surrogates using vsnprintf (which is also ISO)
       RB
     */
    
    #include <stdarg.h>
    extern int _asprintf(char **buf, char *fmt, ...);
    extern int _vasprintf(char **buf, char *fmt, va_list args);
    
    #define asprintf _asprintf
    #define vasprintf _vasprintf

    /* verbosity now partly provided by code, not just macros */

    extern void _verbose(char *fmt, ...),
                _verbose_wonl(char *fmt, ...),
                _verbose_dump (void *_m, void *_start, int length, char *msg),
                _unverbose(void *fmt, ...);

#endif /* __RTFUTILS__ */