/*
 * $Id: safebuf.h,v 1.4 2005/05/01 12:36:46 oldgit Exp $
 * header file for RTF-to-LaTeX2e translation writer code.
 * (c) 2003 Richard Bornat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __SAFEBUF__

#define __SAFEBUF__

    /* really the whole program should be rewritten in OCaml or some such sensible language, but
       I'm not in charge so I can't decide to do that. So here's a safe character-buffer 
       system, with lots of overheads and who cares, but possible space leaks if you miss
       a safebuf_dispose.
       RB
    */

    #include "rtftypes.h"

    typedef struct {
	char *_buf;
	U32 _size, _idx;
    } *SafeBuf;

    extern SafeBuf safebuf_new(size_t size);
    extern void    safebuf_dispose(SafeBuf buf);
    extern void    safebuf_expand(SafeBuf buf, size_t n);
    extern void    safebuf_clear(SafeBuf buf);
    extern void    safebuf_append_ch(SafeBuf buf, char c);
    extern void    safebuf_append_str(SafeBuf buf, char *str);
    extern void    safebuf_assign_str(SafeBuf buf, char *str);
    extern int     safebuf_ncmp(SafeBuf buf, char *s, int n);
    extern char   *safebuf_contents(SafeBuf buf);
    extern int     safebuf_sprintf(SafeBuf buf, char *fmt, ...);

#endif /* __SAFEBUF__ */