#ifndef __VERBOSE_H
    #define __VERBOSE_H

    #include "rtfutils.h"

    #ifdef VERBOSE

        #define verbose				_verbose
        #define verbose_wonl			_verbose_wonl
        #define verbose_d(n)			verbose("%d", n)
        #define verboseU8(expr)			verbose(#expr " = 0x%02x", expr)
        #define verboseU16(expr)		verbose(#expr " = 0x%04x", expr)
        #define verboseU32(expr)		verbose(#expr " = 0x%08lx", expr)
        #define verboseS(expr)			verbose(#expr " = %s", expr)
        #define verboseS_wonl(expr)		verbose_wonl(#expr " = %s", expr)
        #define verbose_dump(rec,len,reclen) 	_verbose_dump ((rec), (rec), ((len)*(reclen)), "")

        #define warning(t)                               \
            do {                                         \
                if (!(t)) {                              \
                    verbose("warning: %s is false", #t); \
                }                                        \
            } while (0)

        #define verboseU32Array(array,len)                                  \
            do {                                                            \
                U32 temp;                                                   \
                for (temp = 0; temp < len; temp++)                          \
                    verbose (#array "[%lu] = 0x%08lx", temp, array [temp]); \
            } while (0)

    #else /* ifndef VERBOSE */

        #define verbose 			_unverbose
        #define verbose_wonl			_unverbose
        #define verbose_d(n)			do {} while (0)
        #define verboseU8(expr)			do {} while (0)
        #define verboseU16(expr)		do {} while (0)
        #define verboseU32(expr)		do {} while (0)
        #define verboseS(expr)			do {} while (0)
        #define verboseS_wonl(expr)		do {} while (0)
        #define verbose_dump(rec,len,reclen) 	do {} while (0)
        #define warning(t)			do {} while (0)
        #define verboseU32Array(array,len) 	do {} while (0)

    #endif /* VERBOSE */

#endif